{- This file is part of irc-fun-messages.
 -
 - Written in 2015 by fr33domlover <fr33domlover@rel4tion.org>.
 -
 - ♡ Copying is an act of love. Please copy, reuse and share.
 -
 - The author(s) have dedicated all copyright and related and neighboring
 - rights to this software to the public domain worldwide. This software is
 - distributed without any warranty.
 -
 - You should have received a copy of the CC0 Public Domain Dedication along
 - with this software. If not, see
 - <http://creativecommons.org/publicdomain/zero/1.0/>.
 -}

module Network.Irc.Messages.Internal.Tokens.Reply
    ( chanpriv
    , prefnicks
    )
where

import Data.Maybe (fromMaybe)
import Network.Irc.Messages.Internal.Tokens.Target
import Network.Irc.Messages.Internal.Types
import Network.Irc.Types
import Text.Regex.Applicative

-------------------------------------------------------------------------------
-- 353 RPL_NAMREPLY
-------------------------------------------------------------------------------

chanpriv :: Regex ChannelPrivacy
chanpriv = Secret <$ sym '@' <|> Private <$ sym '*' <|> Public <$ sym '='

prefnicks :: Regex [(Privilege, Nickname)]
prefnicks = (:) <$> prefnick <*> many (sym ' ' *> prefnick)

prefnick :: Regex (Privilege, Nickname)
prefnick = (,) <$> privilege <*> nickname

privilege :: Regex Privilege
privilege =
    fromMaybe Regular <$> optional (Voice <$ sym '+' <|> Operator <$ sym '@')
